// Totally rewritten by Higmmer
var SageppOverlay = {
	get appVersion() {
		return "2.3.23";
	},

	init: function() {
		function initForFirstRun(prefBranch) {
			if(!hasToolbarButton()) addToolbarButton();

			var BMSVC = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
			var anno = PlacesUtils.annotations;
			var new_folder = BMSVC.createFolder(BMSVC.bookmarksMenuFolder, "Sage Feeds", BMSVC.DEFAULT_INDEX);
			prefBranch.setCharPref("new_folder_id", new_folder);

			var IOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			nodeId = BMSVC.insertBookmark(new_folder, IOService.newURI("http://himag.blog26.fc2.com/?xml&category=16", null, null), -1, "Higmmer's Software News");
			anno.setItemAnnotation(nodeId, "bookmarkProperties/sagestatus", "updated", 0, anno.EXPIRE_NEVER);
		}
		function hasToolbarButton() {
			if ("CustomizableUI" in window) { // for Australis (Fx29+)
				return Boolean(CustomizableUI.getPlacementOfWidget("sage-button"));
			} else { // for legacy toolbar
				var toolbox = document.getElementById("navigator-toolbox");
				for (var i = 0; i < toolbox.childNodes.length; i++) {
					var toolbar = toolbox.childNodes[i];
					if (toolbar.localName == "toolbar" && toolbar.getAttribute("customizable") == "true" && toolbar.currentSet.indexOf("sage-button") > -1)
						return true;
				}
				return false;
			}
		}
		function addToolbarButton() {
			if ("CustomizableUI" in window) { // for Australis (Fx29+)
				CustomizableUI.addWidgetToArea("sage-button", CustomizableUI.AREA_NAVBAR);
			} else { // for legacy toolbar
				var toolbox = document.getElementById("navigator-toolbox");
				for (var i = 0; i < toolbox.childNodes.length; i++) {
					var toolbar = toolbox.childNodes[i];
					if (toolbar.localName == "toolbar" && toolbar.getAttribute("customizable") == "true" && toolbar.id == "nav-bar") {
						var newSet = "";
						var child = ("customizationTarget" in toolbar) ? toolbar.customizationTarget.firstChild : toolbar.firstChild;
						while (child) {
							newSet += child.id + ",";
							child = child.nextSibling;
						}
						newSet += "sage-button";
						toolbar.currentSet = newSet;
						toolbar.setAttribute("currentset", newSet);
						toolbox.ownerDocument.persist(toolbar.id, "currentset");
						try {
							BrowserToolboxCustomizeDone(true);
						} catch (e) {}
						break;
					}
				}
			}
		}
		function setShortcutKey(prefBranch, prefName, keyID) {
			var target;
			try {
				target = document.getElementById(keyID);
				var key = prefBranch.getCharPref(prefName);
				if(key != target.getAttribute("key")) target.setAttribute("key", key);
			} catch (e) {}
			try {
				target = document.getElementById(keyID);
				var modifiers = prefBranch.getCharPref(prefName + ".modifiers");
				if(modifiers != target.getAttribute("modifiers")) target.setAttribute("modifiers", modifiers);
			} catch (e) {}
		}
		function checkMigration(prefBranch, lastVersion) {
			var va = ("0" + lastVersion + ".0.0").split(".");
			var ver = parseInt(va[0])*1000 + parseInt(va[1])*100 + parseInt(va[2]);
			if (ver < 2300) {
				prefBranch.setCharPref("need_to_migrate_from", lastVersion);
			}
		}
		function migratePrefs(prefService) {
			var oldPrefBranch = prefService.getBranch("sage.");
			var newPrefBranch = prefService.getBranch("extensions.sagepp.");

			var uniPrefs = /\.(filter\.adblock_title|user_css.path|user_script.path)$/;
			var funcSet = {};
			[
				[ -1, oldPrefBranch.getComplexValue, newPrefBranch.setComplexValue ],
				[ oldPrefBranch.PREF_STRING, oldPrefBranch.getCharPref, newPrefBranch.setCharPref ],
				[ oldPrefBranch.PREF_INT, oldPrefBranch.getIntPref, newPrefBranch.setIntPref ],
				[ oldPrefBranch.PREF_BOOL, oldPrefBranch.getBoolPref, newPrefBranch.setBoolPref ]
			].forEach(function(item){
				funcSet[item[0]] = { getPref:item[1], setPref:item[2] };
			});

			var children = oldPrefBranch.getChildList("", {});
			for(var i = 0; i < children.length; i++) {
				try {
					var prefName = children[i];
					if(oldPrefBranch.prefHasUserValue(prefName)) {
						var func;
						if(uniPrefs.test(prefName)) {
							func = funcSet[-1];
						} else {
							func = funcSet[oldPrefBranch.getPrefType(prefName)];
						}
						func.setPref(prefName, func.getPref(prefName));
						oldPrefBranch.clearUserPref(prefName);
					}
				} catch (e) {
					alert(e);
				}
			}
		}

		// Initialize Start
		var prefService = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefService.getBranch("extensions.sagepp.");
		if (!prefBranch.prefHasUserValue("last_version")) migratePrefs(prefService);

		var lastVersion = "";
		switch (true) {
		case !prefBranch.prefHasUserValue("new_folder_id"):
			// for new user
			initForFirstRun(prefBranch);
			break;
		case prefBranch.prefHasUserValue("last_version"):
			// for update
			lastVersion = prefBranch.getCharPref("last_version");
			checkMigration(prefBranch, lastVersion);
			break;
		default:
			// maybe migrate from Sage-Too
			prefBranch.setCharPref("need_to_migrate_from", "2.2.0");
		}
		if(this.appVersion != lastVersion) prefBranch.setCharPref("last_version", this.appVersion);

		setShortcutKey(prefBranch, "key.openSidebar",  "key_openSageSidebar");
		setShortcutKey(prefBranch, "key.focusSidebar", "key_focusSageSidebar");

		try {
			prefBranch = prefService.getBranch("extensions.tabmix.opentabfor.");
			prefBranch.getBoolPref("bookmarks");   // Check if TabMixPlus is installed
			prefBranch.setBoolPref("sage", false); // Disable opening new tab by TabMixPlus
		} catch (e) {}
		try {
			prefBranch = prefService.getBranch("extensions.sagepp.auto_check_feeds.");
			if(prefBranch.getCharPref("startup") == "on") prefBranch.setCharPref("startup", "reserved");
		} catch (e) {}
	},

	openAsWin: function(event) {
		if(event.button != 1) return;
		var win = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("winSagePanel");
		if(win) {
			win.focus();
		} else {
			window.openDialog("chrome://sagepp/content/sagepp.xul", "", "chrome,dialog=no,resizable");
		}
	},

	toggleAndFocusSidebar: function(event) {
		var sidebar = document.getElementById('sidebar');
		if(sidebar.parentNode.hidden || sidebar.currentURI.spec != "chrome://sagepp/content/sagepp.xul") {
			sidebar.addEventListener("DOMContentLoaded", function(){
				sidebar.removeEventListener("DOMContentLoaded", arguments.callee, false);
				window.setTimeout(SageppOverlay.focusSidebar, 150);
			}, false);
		}
		toggleSidebar('viewSageSidebar');
	},

	focusSidebar: function(event) {
		if(document.getElementById('sidebar-box').hidden) return;
		var bmTree = document.getElementById('sidebar').contentDocument.getElementById('bookmarksTree');
		if(bmTree) bmTree.focus();
	},

	mozVersionComp: function(version) {
		var verComp = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
		return verComp.compare(appInfo.version, version);
	}
};


window.addEventListener("load", function(){
	window.removeEventListener("load", arguments.callee, false);
	SageppOverlay.init.call(SageppOverlay);
}, false);
