var FeedSearch = {
	RRP_NS: "http://sage.mozdev.org/#",
	SEARCH_ENGINE_RDF: "chrome://sagepp/content/search/searchEngine.rdf",

	RDF:Components.classes['@mozilla.org/rdf/rdf-service;1']
			.getService(Components.interfaces.nsIRDFService),

	txtSearchValue: null,
	imgSearchEngine: null,
	popSearchEngine: null,
	
	rdfDS: null,
	searchEngine: "",
	searchEngineName: "",
	query: "",
	charset: "",
	fieldName: "sagepp-feedsearch", // Added by Higmmer
	
	init: function(){
		this.txtSearchValue = document.getElementById("txtSearchValue");
		this.imgSearchEngine = document.getElementById("imgSearchEngine");
		this.popSearchEngine = document.getElementById("popSearchEngine");
		
		// init Search Engine RDF DataSource
		this.rdfDS = this.RDF.GetDataSource(this.SEARCH_ENGINE_RDF);
		var remote = this.rdfDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
		if(remote.loaded){
			this.initRdfDataSource();
		}else{
			var sink = this.rdfDS.QueryInterface(Components.interfaces.nsIRDFXMLSink);
			sink.addXMLSinkObserver(this.sinkObserver);
		}
		
		if(FirefoxVersion.major >= 24) { // Added by Higmmer
			Components.utils.import("resource://gre/modules/FormHistory.jsm", this);
		}
	},
	
	initRdfDataSource: function(){
		this.popSearchEngine.database.AddDataSource(this.rdfDS);
		this.popSearchEngine.builder.rebuild();
		var tmpSearchEngine = this.txtSearchValue.getAttribute("searchengine");
		if(!tmpSearchEngine)
			tmpSearchEngine = this.getRdfProperty("urn:rrp:searchengine:default", this.RRP_NS + "site");
		this.setSearchEngine(tmpSearchEngine);	
	},
	
	search: function(modifier){
		var searchValue = this.txtSearchValue.value;
		if(searchValue == "") return;

		var searchName = this.searchEngineName + " - " + searchValue;

		// Add search string into search history
		//----- Modified by Higmmer : Start ----->
		// Fix: nsIFormHistory2 is deprecated since Fx24+
		if(FirefoxVersion.major >= 24) {
			let str = searchValue;
			this.FormHistory.count(
				{ fieldname: this.fieldName, value: str },
				{ handleResult: function(count){
					if(count == 0) this.FormHistory.update({
						op: "add",
						fieldname: this.fieldName,
						value: str
					});
				}.bind(this)}
			);
		} else {
			/*// Fix: Feed search does not work in Fx2.0
			var formHistory;
			if("nsIFormHistory" in Components.interfaces) {
				formHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory);
			} else {
				formHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory2);
			}*/
			let formHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory2);;
			formHistory.addEntry(this.fieldName, searchValue);
		}
		//<----- Modified by Higmmer : End -----

		// Escape search string for specified search engine
		var textToSubURI = Components.classes["@mozilla.org/intl/texttosuburi;1"]
								.getService(Components.interfaces.nsITextToSubURI);
		searchValue = textToSubURI.ConvertAndEscape(this.charset, searchValue);

		lastResource = { res:null, db:null, title:searchName, url:this.query + searchValue, uri:this.query + searchValue }; // Modified by Higmmer

		//----- Added by Higmmer : Start ----->
		var openNewTab = CommonFunc.getPrefValue(CommonFunc.OPEN_NEW_TAB, "bool", false);
		if(modifier) openNewTab = !openNewTab;
		CreateHTML.tabbed = CreateHTML.focusNewTab = openNewTab;
		//<----- Added by Higmmer : End -----
		
		setStatusLoading();
		httpGet(lastResource.url);
	},
	
	setSearchEngine: function(aSearchEngine){
		this.searchEngine = aSearchEngine;
		this.searchEngineName = this.getRdfProperty(aSearchEngine, this.RRP_NS + "name");
		this.query = this.getRdfProperty(aSearchEngine, this.RRP_NS + "query");
		this.charset = this.getRdfProperty(aSearchEngine, this.RRP_NS + "charset");

		this.txtSearchValue.setAttribute("searchengine", this.searchEngine);
		this.imgSearchEngine.src = this.getRdfProperty(aSearchEngine, this.RRP_NS + "icon");
	},
	
	popSearchEngineClick: function(aEvent){
		var menuitemNode = aEvent.originalTarget;
		if(menuitemNode.nodeName != "menuitem") return;
		
		this.setSearchEngine(menuitemNode.value);
	},
	
	getRdfProperty: function(aRes, aProperty){
		if(typeof(aRes) == "string") aRes = this.RDF.GetResource(aRes);
		if(typeof(aProperty) == "string") aProperty = this.RDF.GetResource(aProperty);
		var target = this.rdfDS.GetTarget(aRes, aProperty, true);
		try{
			return target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
		}catch(e){
			return target.QueryInterface(Components.interfaces.nsIRDFResource).Value;
		}
	},
	
	sinkObserver: {
		onBeginLoad: function(aSink){},
		onInterrupt: function(aSink){},
		onResume: function(aSink){},
		onEndLoad: function(aSink){
			aSink.removeXMLSinkObserver(this); // Added by Higmmer to fix memory leaks when unloading
			FeedSearch.initRdfDataSource();
		},
		onError: function(aSink, aStatus, aErrorMsg){}
	}
}